<html>
<head>
<title>OgreFrustum.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreFrustum.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreFrustum_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Frustum_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Frustum_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreVertexIndexData_8h.html">OgreVertexIndexData.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovablePlane_8h.html">OgreMovablePlane.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre
<a name="l00039"></a>00039 {
<a name="l00048"></a><a class="code" href="group__Math.html#ga86b4672dfa02cea53b10a52bd6344305">00048</a>     <span class="keyword">enum</span> <a class="code" href="group__Math.html#ga86b4672dfa02cea53b10a52bd6344305" title="Specifies orientation mode.">OrientationMode</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a8e7655727ba9332f3843f46a4d1b126b">00050</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a8e7655727ba9332f3843f46a4d1b126b">OR_DEGREE_0</a>       = 0,
<a name="l00051"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a28c273827e348532e2e5193ddb3c5c0e">00051</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a28c273827e348532e2e5193ddb3c5c0e">OR_DEGREE_90</a>      = 1,
<a name="l00052"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305acd8defb52221ab0634b6456b88777ea9">00052</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305acd8defb52221ab0634b6456b88777ea9">OR_DEGREE_180</a>     = 2,
<a name="l00053"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a2a392843ac77a835af8b3ca000bac382">00053</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a2a392843ac77a835af8b3ca000bac382">OR_DEGREE_270</a>     = 3,
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305abc9559bd9584facb95a611c0111b8894">00055</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305abc9559bd9584facb95a611c0111b8894">OR_PORTRAIT</a>       = <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a8e7655727ba9332f3843f46a4d1b126b">OR_DEGREE_0</a>,
<a name="l00056"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305ac5ccf894975be135988c046317296761">00056</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305ac5ccf894975be135988c046317296761">OR_LANDSCAPERIGHT</a> = <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a28c273827e348532e2e5193ddb3c5c0e">OR_DEGREE_90</a>,
<a name="l00057"></a><a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a286804a9c1f2abd94afa2eaff4ef40c4">00057</a>         <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a286804a9c1f2abd94afa2eaff4ef40c4">OR_LANDSCAPELEFT</a>  = <a class="code" href="group__Math.html#gga86b4672dfa02cea53b10a52bd6344305a2a392843ac77a835af8b3ca000bac382">OR_DEGREE_270</a>
<a name="l00058"></a>00058     };
<a name="l00059"></a>00059 
<a name="l00062"></a><a class="code" href="group__Math.html#gaf5dd9a3d1fd373b17108baa16065b1ce">00062</a>     <span class="keyword">enum</span> <a class="code" href="group__Math.html#gaf5dd9a3d1fd373b17108baa16065b1ce" title="Specifies perspective (realistic) or orthographic (architectural) projection.">ProjectionType</a>
<a name="l00063"></a>00063     {
<a name="l00064"></a><a class="code" href="group__Math.html#ggaf5dd9a3d1fd373b17108baa16065b1cea739a7eabe0426ba0cd2f6e94a5e5be25">00064</a>         <a class="code" href="group__Math.html#ggaf5dd9a3d1fd373b17108baa16065b1cea739a7eabe0426ba0cd2f6e94a5e5be25">PT_ORTHOGRAPHIC</a>,
<a name="l00065"></a><a class="code" href="group__Math.html#ggaf5dd9a3d1fd373b17108baa16065b1ceab93552ced844b58965a168d27150e262">00065</a>         <a class="code" href="group__Math.html#ggaf5dd9a3d1fd373b17108baa16065b1ceab93552ced844b58965a168d27150e262">PT_PERSPECTIVE</a>
<a name="l00066"></a>00066     };
<a name="l00067"></a>00067 
<a name="l00070"></a><a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd">00070</a>     <span class="keyword">enum</span> <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>
<a name="l00071"></a>00071     {
<a name="l00072"></a><a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfdac3491138fb6ea5aab59e7a19df7775cf">00072</a>         <a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfdac3491138fb6ea5aab59e7a19df7775cf">FRUSTUM_PLANE_NEAR</a>   = 0,
<a name="l00073"></a><a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfda0dd893c751a483a18e1345aa88135e8f">00073</a>         <a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfda0dd893c751a483a18e1345aa88135e8f">FRUSTUM_PLANE_FAR</a>    = 1,
<a name="l00074"></a><a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfdaac17072b67144059d69d578706365499">00074</a>         <a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfdaac17072b67144059d69d578706365499">FRUSTUM_PLANE_LEFT</a>   = 2,
<a name="l00075"></a><a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfdab0c99c0e896fe615393fabba067f1a30">00075</a>         <a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfdab0c99c0e896fe615393fabba067f1a30">FRUSTUM_PLANE_RIGHT</a>  = 3,
<a name="l00076"></a><a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfda44c7b45d93e28524064ae95457224a4b">00076</a>         <a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfda44c7b45d93e28524064ae95457224a4b">FRUSTUM_PLANE_TOP</a>    = 4,
<a name="l00077"></a><a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfda4a8d7be432f1ee786179d29dfdf3ee10">00077</a>         <a class="code" href="group__Math.html#gga62275d08557868fd87154c46dfcc9dfda4a8d7be432f1ee786179d29dfdf3ee10">FRUSTUM_PLANE_BOTTOM</a> = 5
<a name="l00078"></a>00078     };
<a name="l00079"></a>00079 
<a name="l00084"></a><a class="code" href="classOgre_1_1Frustum.html">00084</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00085"></a>00085     {
<a name="l00086"></a>00086     <span class="keyword">protected</span>:
<a name="l00088"></a><a class="code" href="classOgre_1_1Frustum.html#a257bb4897e5099d40cd18563c4a2ea86">00088</a>         <a class="code" href="group__Math.html#gaf5dd9a3d1fd373b17108baa16065b1ce" title="Specifies perspective (realistic) or orthographic (architectural) projection.">ProjectionType</a> <a class="code" href="classOgre_1_1Frustum.html#a257bb4897e5099d40cd18563c4a2ea86" title="Orthographic or perspective?">mProjType</a>;
<a name="l00089"></a>00089 
<a name="l00091"></a><a class="code" href="classOgre_1_1Frustum.html#a4a492003ad94e2eeca7505a35af9ad55">00091</a>         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> <a class="code" href="classOgre_1_1Frustum.html#a4a492003ad94e2eeca7505a35af9ad55" title="y-direction field-of-view (default 45)">mFOVy</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1Frustum.html#a8ab90f2c655bb561bdc3ddc6cc09c841">00093</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Frustum.html#a8ab90f2c655bb561bdc3ddc6cc09c841" title="Far clip distance - default 10000.">mFarDist</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1Frustum.html#a34ac27cc8d9fee627e982ce619e7b4f5">00095</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Frustum.html#a34ac27cc8d9fee627e982ce619e7b4f5" title="Near clip distance - default 100.">mNearDist</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1Frustum.html#a2b54e7b0be8ff3a25373711d7515fccd">00097</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Frustum.html#a2b54e7b0be8ff3a25373711d7515fccd" title="x/y viewport ratio - default 1.3333">mAspect</a>;
<a name="l00099"></a><a class="code" href="classOgre_1_1Frustum.html#a0191dabe0fa3574a1840d9ca7e0dbdbc">00099</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Frustum.html#a0191dabe0fa3574a1840d9ca7e0dbdbc" title="Ortho height size (world units)">mOrthoHeight</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1Frustum.html#a5abc693030a4fec3d01154a8070c4cff">00101</a>         <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Frustum.html#a5abc693030a4fec3d01154a8070c4cff" title="Off-axis frustum center offset - default (0.0, 0.0)">mFrustumOffset</a>;
<a name="l00103"></a><a class="code" href="classOgre_1_1Frustum.html#a177498a14b2c554761b68c943081b8ca">00103</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Frustum.html#a177498a14b2c554761b68c943081b8ca" title="Focal length of frustum (for stereo rendering, defaults to 1.0)">mFocalLength</a>;
<a name="l00104"></a>00104 
<a name="l00106"></a><a class="code" href="classOgre_1_1Frustum.html#ada104a8c381f2591dafbad7ee39505e9">00106</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> mFrustumPlanes[6];
<a name="l00107"></a>00107 
<a name="l00109"></a><a class="code" href="classOgre_1_1Frustum.html#af2ef6482cac8346b018aefe94fa32d95">00109</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Frustum.html#af2ef6482cac8346b018aefe94fa32d95" title="Stored versions of parent orientation / position.">mLastParentOrientation</a>;
<a name="l00110"></a><a class="code" href="classOgre_1_1Frustum.html#a537832e50586f4141309ed0fa89a67cf">00110</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Frustum.html#a537832e50586f4141309ed0fa89a67cf">mLastParentPosition</a>;
<a name="l00111"></a>00111 
<a name="l00113"></a><a class="code" href="classOgre_1_1Frustum.html#a29d108bc5a1cec51f8d11c6c5f6c533d">00113</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1Frustum.html#a29d108bc5a1cec51f8d11c6c5f6c533d" title="Pre-calced projection matrix for the specific render system.">mProjMatrixRS</a>;
<a name="l00115"></a><a class="code" href="classOgre_1_1Frustum.html#a844fddb67b8d0a480c8729f24aa57d7d">00115</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1Frustum.html#a844fddb67b8d0a480c8729f24aa57d7d" title="Pre-calced standard projection matrix but with render system depth range.">mProjMatrixRSDepth</a>;
<a name="l00117"></a><a class="code" href="classOgre_1_1Frustum.html#a903bf406715d785bc31bf507688e698b">00117</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1Frustum.html#a903bf406715d785bc31bf507688e698b" title="Pre-calced standard projection matrix.">mProjMatrix</a>;
<a name="l00119"></a><a class="code" href="classOgre_1_1Frustum.html#add3a630e8c14a0e3636bc7148cb8cfcb">00119</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1Frustum.html#add3a630e8c14a0e3636bc7148cb8cfcb" title="Pre-calced view matrix.">mViewMatrix</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1Frustum.html#a216eb2f30322a95683409d521c2360e9">00121</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#a216eb2f30322a95683409d521c2360e9" title="Something&#39;s changed in the frustum shape?">mRecalcFrustum</a>;
<a name="l00123"></a><a class="code" href="classOgre_1_1Frustum.html#af1da8cc341ff34649c2f2a0d2d84991d">00123</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#af1da8cc341ff34649c2f2a0d2d84991d" title="Something re the view pos has changed.">mRecalcView</a>;
<a name="l00125"></a><a class="code" href="classOgre_1_1Frustum.html#a1aa8fe4e036913b93614567b4174e39b">00125</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#a1aa8fe4e036913b93614567b4174e39b" title="Something re the frustum planes has changed.">mRecalcFrustumPlanes</a>;
<a name="l00127"></a><a class="code" href="classOgre_1_1Frustum.html#aba98dbaecb72719899feefae86cd1050">00127</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#aba98dbaecb72719899feefae86cd1050" title="Something re the world space corners has changed.">mRecalcWorldSpaceCorners</a>;
<a name="l00129"></a><a class="code" href="classOgre_1_1Frustum.html#a1fede4ca39ecafca43bcb84168176cc8">00129</a>         <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#a1fede4ca39ecafca43bcb84168176cc8" title="Something re the vertex data has changed.">mRecalcVertexData</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1Frustum.html#a3e12ccd50a5db589784aed0cd8d3d716">00131</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#a3e12ccd50a5db589784aed0cd8d3d716" title="Are we using a custom view matrix?">mCustomViewMatrix</a>;
<a name="l00133"></a><a class="code" href="classOgre_1_1Frustum.html#acb9cc98539f7f9423aaebc34b24c900e">00133</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#acb9cc98539f7f9423aaebc34b24c900e" title="Are we using a custom projection matrix?">mCustomProjMatrix</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1Frustum.html#a416928f41511d946f5190032149813c5">00135</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#a416928f41511d946f5190032149813c5" title="Have the frustum extents been manually set?">mFrustumExtentsManuallySet</a>;
<a name="l00137"></a><a class="code" href="classOgre_1_1Frustum.html#af923e5e934a48a11251752e983761209">00137</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mLeft, mRight, <a class="code" href="classOgre_1_1Frustum.html#af923e5e934a48a11251752e983761209">mTop</a>, mBottom;
<a name="l00139"></a><a class="code" href="classOgre_1_1Frustum.html#aecb19efdd904fef28efde2173713e233">00139</a>         <span class="keyword">mutable</span> <a class="code" href="group__Math.html#ga86b4672dfa02cea53b10a52bd6344305" title="Specifies orientation mode.">OrientationMode</a> <a class="code" href="classOgre_1_1Frustum.html#aecb19efdd904fef28efde2173713e233" title="Frustum orientation mode.">mOrientationMode</a>;
<a name="l00140"></a>00140         
<a name="l00141"></a>00141         <span class="comment">// Internal functions for calcs</span>
<a name="l00142"></a>00142         <span class="keyword">virtual</span> <span class="keywordtype">void</span> calcProjectionParameters(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; bottom, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; top) <span class="keyword">const</span>;
<a name="l00144"></a>00144         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateFrustum(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00146"></a>00146         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateView(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00148"></a>00148         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateFrustumImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00150"></a>00150         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateViewImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00151"></a>00151         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateFrustumPlanes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00153"></a>00153         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateFrustumPlanesImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00154"></a>00154         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateWorldSpaceCorners(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00156"></a>00156         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateWorldSpaceCornersImpl(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00157"></a>00157         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateVertexData(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00158"></a>00158         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isViewOutOfDate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00159"></a>00159         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isFrustumOutOfDate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00161"></a>00161         <span class="keyword">virtual</span> <span class="keywordtype">void</span> invalidateFrustum(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00163"></a>00163         <span class="keyword">virtual</span> <span class="keywordtype">void</span> invalidateView(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00164"></a>00164 
<a name="l00166"></a><a class="code" href="classOgre_1_1Frustum.html#ad7ea756f8035afdd04d17c7311d39866">00166</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Frustum.html#ad7ea756f8035afdd04d17c7311d39866" title="Shared class-level name for Movable type.">msMovableType</a>;
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classOgre_1_1Frustum.html#a8a4b17edc9eed5403b8b6f9556519046">00168</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1Frustum.html#a8a4b17edc9eed5403b8b6f9556519046">mBoundingBox</a>;
<a name="l00169"></a><a class="code" href="classOgre_1_1Frustum.html#aaca3927c89f24deffa69daf6ec0e4e32">00169</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> <a class="code" href="classOgre_1_1Frustum.html#aaca3927c89f24deffa69daf6ec0e4e32">mVertexData</a>;
<a name="l00170"></a>00170 
<a name="l00171"></a><a class="code" href="classOgre_1_1Frustum.html#a1cc270d808fea9899ac42cc8555e6d96">00171</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1Frustum.html#a1cc270d808fea9899ac42cc8555e6d96">mMaterial</a>;
<a name="l00172"></a><a class="code" href="classOgre_1_1Frustum.html#a77efd6b15016c176acee6173a11b7863">00172</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mWorldSpaceCorners[8];
<a name="l00173"></a>00173 
<a name="l00175"></a><a class="code" href="classOgre_1_1Frustum.html#a3859ea17ae6010675a1f89f94aa42938">00175</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#a3859ea17ae6010675a1f89f94aa42938" title="Is this frustum to act as a reflection of itself?">mReflect</a>;
<a name="l00177"></a><a class="code" href="classOgre_1_1Frustum.html#ad7a927fc99844d9956548c9df7b58f3f">00177</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1Frustum.html#ad7a927fc99844d9956548c9df7b58f3f" title="Derived reflection matrix.">mReflectMatrix</a>;
<a name="l00179"></a><a class="code" href="classOgre_1_1Frustum.html#adb716db38ea28ca3d60f191d8df7d803">00179</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> <a class="code" href="classOgre_1_1Frustum.html#adb716db38ea28ca3d60f191d8df7d803" title="Fixed reflection plane.">mReflectPlane</a>;
<a name="l00181"></a><a class="code" href="classOgre_1_1Frustum.html#ab3d33bd79f6f435e033361ff363e879d">00181</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a>* <a class="code" href="classOgre_1_1Frustum.html#ab3d33bd79f6f435e033361ff363e879d" title="Pointer to a reflection plane (automatically updated)">mLinkedReflectPlane</a>;
<a name="l00183"></a><a class="code" href="classOgre_1_1Frustum.html#a00209fe9cdcef7a60f060188c8cc4a14">00183</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> <a class="code" href="classOgre_1_1Frustum.html#a00209fe9cdcef7a60f060188c8cc4a14" title="Record of the last world-space reflection plane info used.">mLastLinkedReflectionPlane</a>;
<a name="l00184"></a>00184         
<a name="l00186"></a><a class="code" href="classOgre_1_1Frustum.html#ab7df717a87a472b90eeb7a021edd29d1">00186</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#ab7df717a87a472b90eeb7a021edd29d1" title="Is this frustum using an oblique depth projection?">mObliqueDepthProjection</a>;
<a name="l00188"></a><a class="code" href="classOgre_1_1Frustum.html#a446a977d90b826ce4ecb54e220955e0f">00188</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> <a class="code" href="classOgre_1_1Frustum.html#a446a977d90b826ce4ecb54e220955e0f" title="Fixed oblique projection plane.">mObliqueProjPlane</a>;
<a name="l00190"></a><a class="code" href="classOgre_1_1Frustum.html#aaba0ab07ce71b18d5c4eeda90e3527ff">00190</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a>* <a class="code" href="classOgre_1_1Frustum.html#aaba0ab07ce71b18d5c4eeda90e3527ff" title="Pointer to oblique projection plane (automatically updated)">mLinkedObliqueProjPlane</a>;
<a name="l00192"></a><a class="code" href="classOgre_1_1Frustum.html#a17d1aff83996f2af8b7ddcb1f53e0c94">00192</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> <a class="code" href="classOgre_1_1Frustum.html#a17d1aff83996f2af8b7ddcb1f53e0c94" title="Record of the last world-space oblique depth projection plane info used.">mLastLinkedObliqueProjPlane</a>;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194     <span class="keyword">public</span>:
<a name="l00195"></a>00195 
<a name="l00197"></a>00197         <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>();
<a name="l00212"></a>00212         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFOVy(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy);
<a name="l00213"></a>00213 
<a name="l00216"></a>00216         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; getFOVy(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00217"></a>00217 
<a name="l00229"></a>00229         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setNearClipDistance(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearDist);
<a name="l00230"></a>00230 
<a name="l00233"></a>00233         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getNearClipDistance(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00234"></a>00234 
<a name="l00255"></a>00255         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFarClipDistance(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farDist);
<a name="l00256"></a>00256 
<a name="l00259"></a>00259         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFarClipDistance(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00260"></a>00260 
<a name="l00269"></a>00269         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAspectRatio(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> ratio);
<a name="l00270"></a>00270 
<a name="l00273"></a>00273         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAspectRatio(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00274"></a>00274 
<a name="l00286"></a>00286         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFrustumOffset(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; offset);
<a name="l00287"></a>00287 
<a name="l00301"></a>00301         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFrustumOffset(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> horizontal = 0.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> vertical = 0.0);
<a name="l00302"></a>00302 
<a name="l00305"></a>00305         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; getFrustumOffset() <span class="keyword">const</span>;
<a name="l00306"></a>00306 
<a name="l00311"></a>00311         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFocalLength(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> focalLength = 1.0);
<a name="l00312"></a>00312 
<a name="l00315"></a>00315         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFocalLength() <span class="keyword">const</span>;
<a name="l00316"></a>00316 
<a name="l00321"></a>00321         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFrustumExtents(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom);
<a name="l00323"></a>00323         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetFrustumExtents(); 
<a name="l00325"></a>00325         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getFrustumExtents(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; outleft, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; outright, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; outtop, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; outbottom) <span class="keyword">const</span>;
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00337"></a>00337         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; getProjectionMatrixRS(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00349"></a>00349         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; getProjectionMatrixWithRSDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00359"></a>00359         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; getProjectionMatrix(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00360"></a>00360 
<a name="l00363"></a>00363         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; getViewMatrix(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00364"></a>00364 
<a name="l00369"></a>00369         <span class="keyword">virtual</span> <span class="keywordtype">void</span> calcViewMatrixRelative(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; relPos, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matToUpdate) <span class="keyword">const</span>;
<a name="l00370"></a>00370 
<a name="l00388"></a>00388         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCustomViewMatrix(<span class="keywordtype">bool</span> enable, 
<a name="l00389"></a>00389             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; viewMatrix = <a class="code" href="classOgre_1_1Matrix4.html#af2f61127dd1911c9ac2b4cbc0b4f3668">Matrix4::IDENTITY</a>);
<a name="l00391"></a><a class="code" href="classOgre_1_1Frustum.html#aca4236e8e7772eb12b1aab870efa2c3f">00391</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isCustomViewMatrixEnabled(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00392"></a>00392 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mCustomViewMatrix; }
<a name="l00393"></a>00393         
<a name="l00413"></a>00413         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCustomProjectionMatrix(<span class="keywordtype">bool</span> enable, 
<a name="l00414"></a>00414             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; projectionMatrix = <a class="code" href="classOgre_1_1Matrix4.html#af2f61127dd1911c9ac2b4cbc0b4f3668">Matrix4::IDENTITY</a>);
<a name="l00416"></a><a class="code" href="classOgre_1_1Frustum.html#a16e00143dd34480120aeb370f222551a">00416</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isCustomProjectionMatrixEnabled(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00417"></a>00417 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mCustomProjMatrix; }
<a name="l00418"></a>00418 
<a name="l00423"></a>00423         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>* getFrustumPlanes(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00424"></a>00424 
<a name="l00429"></a>00429         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; getFrustumPlane( <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> plane ) <span class="keyword">const</span>;
<a name="l00430"></a>00430 
<a name="l00442"></a>00442         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; bound, <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>* culledBy = 0) <span class="keyword">const</span>;
<a name="l00443"></a>00443 
<a name="l00455"></a>00455         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; bound, <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>* culledBy = 0) <span class="keyword">const</span>;
<a name="l00456"></a>00456 
<a name="l00468"></a>00468         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vert, <a class="code" href="group__Math.html#ga62275d08557868fd87154c46dfcc9dfd" title="Worldspace clipping planes.">FrustumPlane</a>* culledBy = 0) <span class="keyword">const</span>;
<a name="l00469"></a>00469 
<a name="l00471"></a>00471         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> getTypeFlags(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00472"></a>00472 
<a name="l00474"></a>00474         <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00475"></a>00475 
<a name="l00477"></a>00477         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBoundingRadius(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00478"></a>00478 
<a name="l00480"></a>00480         <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00481"></a>00481 
<a name="l00483"></a>00483         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00484"></a>00484 
<a name="l00486"></a>00486         <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00487"></a>00487 
<a name="l00489"></a>00489         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00490"></a>00490 
<a name="l00492"></a>00492         <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00493"></a>00493 
<a name="l00495"></a>00495         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00496"></a>00496 
<a name="l00498"></a>00498         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00499"></a>00499 
<a name="l00501"></a>00501         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00502"></a>00502 
<a name="l00509"></a>00509         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* getWorldSpaceCorners(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00510"></a>00510 
<a name="l00513"></a>00513         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setProjectionType(<a class="code" href="group__Math.html#gaf5dd9a3d1fd373b17108baa16065b1ce" title="Specifies perspective (realistic) or orthographic (architectural) projection.">ProjectionType</a> pt);
<a name="l00514"></a>00514 
<a name="l00517"></a>00517         <span class="keyword">virtual</span> <a class="code" href="group__Math.html#gaf5dd9a3d1fd373b17108baa16065b1ce" title="Specifies perspective (realistic) or orthographic (architectural) projection.">ProjectionType</a> getProjectionType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00518"></a>00518 
<a name="l00526"></a>00526         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrthoWindow(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> h);
<a name="l00531"></a>00531         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrthoWindowHeight(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> h);
<a name="l00536"></a>00536         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrthoWindowWidth(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w);
<a name="l00539"></a>00539         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOrthoWindowHeight() <span class="keyword">const</span>;
<a name="l00543"></a>00543         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOrthoWindowWidth() <span class="keyword">const</span>;
<a name="l00544"></a>00544 
<a name="l00550"></a>00550         <span class="keyword">virtual</span> <span class="keywordtype">void</span> enableReflection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; p);
<a name="l00559"></a>00559         <span class="keyword">virtual</span> <span class="keywordtype">void</span> enableReflection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a>* p);
<a name="l00560"></a>00560 
<a name="l00562"></a>00562         <span class="keyword">virtual</span> <span class="keywordtype">void</span> disableReflection(<span class="keywordtype">void</span>);
<a name="l00563"></a>00563 
<a name="l00565"></a><a class="code" href="classOgre_1_1Frustum.html#ab4ccb0de72fc814a908c766aca5d6323">00565</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Frustum.html#ab4ccb0de72fc814a908c766aca5d6323" title="Returns whether this frustum is being reflected.">isReflected</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mReflect; }
<a name="l00567"></a><a class="code" href="classOgre_1_1Frustum.html#a5c899f5f08eafa4f48390560a259ab18">00567</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; <a class="code" href="classOgre_1_1Frustum.html#a5c899f5f08eafa4f48390560a259ab18" title="Returns the reflection matrix of the frustum if appropriate.">getReflectionMatrix</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mReflectMatrix; }
<a name="l00569"></a><a class="code" href="classOgre_1_1Frustum.html#ac668c08229a20ba1e29ce6175e6ecd18">00569</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; <a class="code" href="classOgre_1_1Frustum.html#ac668c08229a20ba1e29ce6175e6ecd18" title="Returns the reflection plane of the frustum if appropriate.">getReflectionPlane</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mReflectPlane; }
<a name="l00570"></a>00570 
<a name="l00580"></a>00580         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> projectSphere(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; sphere, 
<a name="l00581"></a>00581             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* bottom) <span class="keyword">const</span>;
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 
<a name="l00609"></a>00609         <span class="keyword">virtual</span> <span class="keywordtype">void</span> enableCustomNearClipPlane(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovablePlane.html" title="Definition of a Plane that may be attached to a node, and the derived details of it retrieved simply...">MovablePlane</a>* plane);
<a name="l00630"></a>00630         <span class="keyword">virtual</span> <span class="keywordtype">void</span> enableCustomNearClipPlane(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane);
<a name="l00632"></a>00632         <span class="keyword">virtual</span> <span class="keywordtype">void</span> disableCustomNearClipPlane(<span class="keywordtype">void</span>);
<a name="l00634"></a><a class="code" href="classOgre_1_1Frustum.html#ad0049ea182aa84b12638a9c834bd3be7">00634</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isCustomNearClipPlaneEnabled(<span class="keywordtype">void</span>)<span class="keyword"> const </span>
<a name="l00635"></a>00635 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mObliqueDepthProjection; }
<a name="l00636"></a>00636 
<a name="l00638"></a>00638         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00639"></a>00639             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00640"></a>00640 
<a name="l00642"></a><a class="code" href="classOgre_1_1Frustum.html#ac7acc269343061227ef05ea335c8500f">00642</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Frustum.html#ac7acc269343061227ef05ea335c8500f" title="Small constant used to reduce far plane projection to avoid inaccuracies.">INFINITE_FAR_PLANE_ADJUST</a>;
<a name="l00643"></a>00643 
<a name="l00645"></a>00645         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPositionForViewUpdate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00647"></a>00647         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getOrientationForViewUpdate(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00648"></a>00648 
<a name="l00651"></a>00651         <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a> getPlaneBoundedVolume();
<a name="l00657"></a>00657         <span class="keywordtype">void</span> setOrientationMode(<a class="code" href="group__Math.html#ga86b4672dfa02cea53b10a52bd6344305" title="Specifies orientation mode.">OrientationMode</a> orientationMode);
<a name="l00658"></a>00658 
<a name="l00664"></a>00664         <a class="code" href="group__Math.html#ga86b4672dfa02cea53b10a52bd6344305" title="Specifies orientation mode.">OrientationMode</a> getOrientationMode() <span class="keyword">const</span>;
<a name="l00665"></a>00665 
<a name="l00666"></a>00666     };
<a name="l00667"></a>00667 
<a name="l00671"></a>00671 }
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 <span class="preprocessor">#endif </span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
